---
title: Object.prototype.isPrototypeOf()
slug: Web/JavaScript/Reference/Global_Objects/Object/isPrototypeOf
tags:
  - JavaScript
  - Method
  - Object
  - Prototype
  - Reference
  - isPrototype
---
<div>{{JSRef}}</div>

<p>The <code><strong>isPrototypeOf()</strong></code> method checks if an object exists in another object's prototype chain.</p>

<div>{{EmbedInteractiveExample("pages/js/object-prototype-isprototypeof.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div class="note">
<p><code>isPrototypeOf()</code> differs from the {{jsxref("Operators/instanceof", "instanceof")}} operator. In the expression "<code>object instanceof AFunction</code>", the <code>object</code> prototype chain is checked against <code>AFunction.prototype</code>, not against <code>AFunction</code> itself.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>prototypeObj</var>.isPrototypeOf(<var>object</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>object</var></code></dt>
 <dd>The object whose prototype chain will be searched.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} indicating whether the calling object lies in the prototype chain of the specified object.</p>

<h3 id="Errors_thrown">Errors thrown</h3>

<dl>
 <dt>{{jsxref("TypeError")}}</dt>
 <dd>A {{jsxref("TypeError")}} is thrown if <code><var>prototypeObj</var></code> is undefined or null.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The <code>isPrototypeOf()</code> method allows you to check whether or not an object exists within another object's prototype chain.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_isPrototypeOf">Using isPrototypeOf</h3>

<p>This example demonstrates that <code>Baz.prototype</code>, <code>Bar.prototype</code>, <code>Foo.prototype</code> and <code>Object.prototype</code> exist in the prototype chain for object <code>baz</code>:</p>

<pre class="brush: js notranslate">function Foo() {}
function Bar() {}
function Baz() {}

Bar.prototype = Object.create(Foo.prototype);
Baz.prototype = Object.create(Bar.prototype);

var baz = new Baz();

console.log(Baz.prototype.isPrototypeOf(baz)); // true
console.log(Bar.prototype.isPrototypeOf(baz)); // true
console.log(Foo.prototype.isPrototypeOf(baz)); // true
console.log(Object.prototype.isPrototypeOf(baz)); // true
</pre>

<p><code>isPrototypeOf()</code> method, along with the {{jsxref("Operators/instanceof", "instanceof")}} operator particularly comes in handy if you have code that can only function when dealing with objects descended from a specific prototype chain, e.g., to guarantee that certain methods or properties will be present on that object.</p>

<p>For example, check if <code>baz</code> object descends from <code>Foo.prototype</code>:</p>

<pre class="brush: js notranslate">if (Foo.prototype.isPrototypeOf(baz)) {
  // do something safe
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object.prototype.isprototypeof', 'Object.prototype.isPrototypeOf')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Object.isPrototypeOf")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Operators/instanceof", "instanceof")}}</li>
 <li>{{jsxref("Object.getPrototypeOf()")}}</li>
 <li>
  <div>{{jsxref("Object.setPrototypeOf()")}}</div>
 </li>
 <li>{{jsxref("Object.prototype.__proto__")}} </li>
</ul>
